//(c) Teddy Warner 28 May 2021

//This work may be reproduced, modified, distributed, performed, and displayed 
//for any purpose, but must acknowledge the Assistive Aquaponics Fish Tank. 
//Copyright is retained and must be preserved. The work is provided as is; 
//no warranty is provided, and users accept all liability.

#include <LiquidCrystal.h>
#include <SoftwareSerial.h>    

SoftwareSerial portDHT(2, 3);
SoftwareSerial portPH(4, 5);

const int rs = 12, en = 11, d4 = 10, d5 = 9, d6 = 8, d7 = 7;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);

String Temp;
String Humidity;
String pH;

byte fishbl[] = {
  B00011,
  B00111,
  B01111,
  B01111,
  B00110,
  B00000,
  B00000,
  B00000
};

byte fishbr[] = {
  B11000,
  B11100,
  B11110,
  B11110,
  B01100,
  B00000,
  B00000,
  B00000
};

byte fishml[] = {
  B11111,
  B11111,
  B11111,
  B01111,
  B01111,
  B00111,
  B00111,
  B00011
};

byte fishmr[] = {
  B11111,
  B11111,
  B11111,
  B11110,
  B11110,
  B11100,
  B11100,
  B11000

};

byte fishtl[] = {
  B00000,
  B00000,
  B00000,
  B00011,
  B00111,
  B01111,
  B01111,
  B11111
};

byte fishtr[] = {
  B00000,
  B00000,
  B00000,
  B11000,
  B11100,
  B11110,
  B11110,
  B11111
};

void setup() {

  Serial.begin(9600);
  portDHT.begin(9600);
  portPH.begin(9600);
  
  lcd.begin(20, 4);

  lcd.setCursor(0,0);
    lcd.print("--------------------");
  lcd.setCursor(0,1);
    lcd.print("Aquaponics Fish Tank");
  lcd.setCursor(0,2);
    lcd.print("... In Development");
  lcd.setCursor(0,3);
    lcd.print("--------------------");

  delay(5000);
  lcd.clear();

}

void loop() {

 lcd.createChar(1,fishtl);
 lcd.createChar(2,fishtr);
 lcd.createChar(3,fishml);
 lcd.createChar(4,fishmr);
 lcd.createChar(5,fishbl);
 lcd.createChar(6,fishbr);

 lcd.setCursor(0,0); 
 lcd.print("Aquaponics Fish Tank");

  lcd.setCursor(0,1);  
  lcd.write(1);
  lcd.setCursor(1,1);
  lcd.write(2);
  lcd.setCursor(0,2);
  lcd.write(3);
  lcd.setCursor(1,2);
  lcd.write(4);
  lcd.setCursor(0,3);
  lcd.write(5);
  lcd.setCursor(1,3);
  lcd.write(6);

 String IN;
 String readString;

 portDHT.listen();
 portDHT.print(F("AT\r\n"));     

 delay(100);

while(portDHT.available()) {
  delay(100);
  if (portDHT.available() > 0) { 
    char c = portDHT.read();
    readString += c;
  }
 }

 IN = readString;

 if(IN.substring(0,1)=="1"){
  Temp = IN.substring(1);
  lcd.setCursor(3,1);
  lcd.print(Temp);
 }

  lcd.setCursor(15,1);
  lcd.print(" ");
  lcd.setCursor(16,1);
  lcd.print(" ");

 if(IN.substring(0,1)=="2"){
  Humidity = IN.substring(1);
  lcd.setCursor(3,2);
  lcd.print(Humidity);
 }

  lcd.setCursor(19,2);
  lcd.print(" ");
 
 portPH.listen();
 portPH.print(F("AT\r\n"));     

 delay(100);

while(portPH.available()) {
  delay(100);
  if (portPH.available() > 0) { 
    char b = portPH.read();
  readString += b;
  }
 }
 
 IN = readString;

 if(IN.substring(0,1)=="3"){
  pH = IN.substring(1);
  lcd.setCursor(3,3);
  lcd.print(pH);
 }

  lcd.setCursor(13,3);
  lcd.print(" ");
  lcd.setCursor(14,3);
  lcd.print(" ");
 
}
